; compiler: jal jalv25r7 (compiled Jan 29 2023)

; command line:  C:\\jallib1.8\\compiler\\jalv2_64.exe C:\Users\pcser\Documents\Hobbielektronika\2023HE\JAL\Lab02\sw_serial_h.jal -s C://jallib1.8//lib
                                list p=12f683, r=dec
                                errorlevel -306 ; no page boundary warnings
                                errorlevel -302 ; no bank 0 warnings
                                errorlevel -202 ; no 'argument out of range' warnings

                             __config 0x3ff4
datahi_set macro val
  bsf 3, 6 ; STATUS<rp1>
  endm
datahi_clr macro val
  bcf 3, 6 ; STATUS<rp1>
  endm
datalo_set macro val
  bsf 3, 5 ; STATUS<rp0>
  endm
datalo_clr macro val
  bcf 3, 5 ; STATUS<rp0>
  endm
irp_clr macro
  bcf 3, 7 ; STATUS<irp>
  endm
irp_set macro
  bsf 3, 7 ; STATUS<irp>
  endm
branchhi_set macro lbl
  nop
  endm
branchhi_clr macro lbl
  nop
  endm
branchlo_set macro lbl
    bsf 10, 3 ; PCLATH<3>
  endm
branchlo_clr macro lbl
    bcf 10, 3 ; PCLATH<3>
  endm
v_false                        EQU 0
v_high                         EQU 1
v_low                          EQU 0
v_input                        EQU 1
v_output                       EQU 0
v__status                      EQU 0x0003  ; _status
v__c                           EQU 0
v__z                           EQU 2
v_gpio_                        EQU 0x0005  ; gpio_
v_porta_shadow_                EQU 0x007d  ; porta_shadow_
v_intcon                       EQU 0x000b  ; intcon
v_intcon_gie                   EQU 0x000b  ; intcon_gie-->intcon:7
v_cmcon0                       EQU 0x0019  ; cmcon0
v_cmcon1                       EQU 0x001a  ; cmcon1
v_adcon0                       EQU 0x001f  ; adcon0
v_trisio                       EQU 0x0085  ; trisio
v_pin_a0_direction             EQU 0x0085  ; pin_a0_direction-->trisio:0
v_pin_a1_direction             EQU 0x0085  ; pin_a1_direction-->trisio:1
v_osccon                       EQU 0x008f  ; osccon
v_ansel                        EQU 0x009f  ; ansel
v_serial_sw_databits           EQU 8
v__pic_temp                    EQU 0x0020  ; _pic_temp-->_pic_state
v__pic_state                   EQU 0x0020  ; _pic_state
v___data_5                     EQU 0x0023  ; _serial_sw_data_put:data
v___data_1                     EQU 0x0025  ; serial_sw_write:data
v_gie_old                      EQU 0x0028  ; serial_sw_write:gie_old-->_bitbucket5:0
v_data_bit                     EQU 0x0025  ; serial_sw_write:data_bit-->data1:0
v__floop9                      EQU 0x0026  ; serial_sw_write:_floop9
v____bitbucket_5               EQU 0x0028  ; serial_sw_write:_bitbucket
v___x_23                       EQU 0x007d  ; serial_sw_write:x-->porta_shadow_:0
v___x_24                       EQU 0x007d  ; serial_sw_write:x-->porta_shadow_:0
v___x_25                       EQU 0x007d  ; serial_sw_write:x-->porta_shadow_:0
v___x_22                       EQU 0x007d  ; serial_sw_init:x-->porta_shadow_:0
v___n_3                        EQU 0x0023  ; delay_1ms:n
v__floop3                      EQU 0x0026  ; delay_1ms:_floop3
v__floop4                      EQU 0x0029  ; delay_1ms:_floop4
;    1 include 12f683                            -- PIC céláramkör
                               org      0
l__main
;    5 OSCCON_IRCF   = 0b_111                    -- Fosc = 8 MHz beállítása
                               movlw    143
                               datalo_set v_osccon
                               andwf    v_osccon,w
                               iorlw    112
                               movwf    v_osccon
; C://jallib1.8//lib/delay.jal
;   25 procedure delay_1us() is
                               goto     l__l85
;  112 procedure delay_1ms(word in n) is
l_delay_1ms
;  114    for n loop
                               movf     v___n_3,w
                               movwf    v__floop3
                               movf     v___n_3+1,w
                               movwf    v__floop3+1
                               clrf     v__floop4
                               clrf     v__floop4+1
                               goto     l__l76
l__l75
;  116          _usec_delay(_one_ms_delay)
                               datalo_clr v__pic_temp
                               datahi_clr v__pic_temp
                               movlw    3
                               movwf    v__pic_temp
l__l177
                               movlw    131
                               movwf    v__pic_temp+1
l__l178
                               branchhi_clr l__l178
                               branchlo_clr l__l178
                               decfsz   v__pic_temp+1,f
                               goto     l__l178
                               branchhi_clr l__l177
                               branchlo_clr l__l177
                               decfsz   v__pic_temp,f
                               goto     l__l177
;  120    end loop
                               incf     v__floop4,f
                               btfsc    v__status, v__z
                               incf     v__floop4+1,f
l__l76
                               movf     v__floop4,w
                               subwf    v__floop3,w
                               movwf    v__pic_temp
                               movf     v__floop4+1,w
                               subwf    v__floop3+1,w
                               iorwf    v__pic_temp,w
                               btfss    v__status, v__z
                               goto     l__l75
;  121 end procedure
                               return   
;  137 end procedure
l__l85
; C:\Users\pcser\Documents\Hobbielektronika\2023HE\JAL\Lab02\sw_serial_h.jal
;    7 enable_digital_io()
; C://jallib1.8//lib/12f683.jal
;  488    ANSEL  = 0b0000_0000
                               clrf     v_ansel
; C:\Users\pcser\Documents\Hobbielektronika\2023HE\JAL\Lab02\sw_serial_h.jal
;    7 enable_digital_io()
; C://jallib1.8//lib/12f683.jal
;  510    analog_off()
; C:\Users\pcser\Documents\Hobbielektronika\2023HE\JAL\Lab02\sw_serial_h.jal
;    7 enable_digital_io()
; C://jallib1.8//lib/12f683.jal
;  495    ADCON0 = 0b0000_0000
                               datalo_clr v_adcon0
                               clrf     v_adcon0
; C:\Users\pcser\Documents\Hobbielektronika\2023HE\JAL\Lab02\sw_serial_h.jal
;    7 enable_digital_io()
; C://jallib1.8//lib/12f683.jal
;  511    adc_off()
; C:\Users\pcser\Documents\Hobbielektronika\2023HE\JAL\Lab02\sw_serial_h.jal
;    7 enable_digital_io()
; C://jallib1.8//lib/12f683.jal
;  502    CMCON0 = 0b0000_0111
                               movlw    7
                               movwf    v_cmcon0
;  503    CMCON1 = 0b0000_0000
                               clrf     v_cmcon1
; C:\Users\pcser\Documents\Hobbielektronika\2023HE\JAL\Lab02\sw_serial_h.jal
;    7 enable_digital_io()
; C://jallib1.8//lib/12f683.jal
;  512    comparator_off()
; C:\Users\pcser\Documents\Hobbielektronika\2023HE\JAL\Lab02\sw_serial_h.jal
;    7 enable_digital_io()
;   11 pin_A0_direction = output                 -- TX az UART kimenet
                               datalo_set v_trisio ; pin_a0_direction
                               bcf      v_trisio, 0 ; pin_a0_direction
;   12 pin_A1_direction = input                  -- RX az UART bemenet
                               bsf      v_trisio, 1 ; pin_a1_direction
; C://jallib1.8//lib/serial_software.jal
;   47 elsif defined(INTCON0_GIE) then
                               goto     l__l148
;   74 procedure serial_sw_init() is
l_serial_sw_init
;   77       serial_sw_tx_pin = high
                               bsf      v_porta_shadow_, 0 ; x22
; C://jallib1.8//lib/12f683.jal
;  128    PORTA_ = PORTA_shadow_
                               movf     v_porta_shadow_,w
                               datalo_clr v_gpio_
                               movwf    v_gpio_
; C://jallib1.8//lib/serial_software.jal
;   77       serial_sw_tx_pin = high
;   81 end procedure
                               return   
;   93 procedure serial_sw_write(byte in data) is
l_serial_sw_write
                               movwf    v___data_1
;   99    gie_old = serial_sw_interrupt
                               bcf      v____bitbucket_5, 0 ; gie_old
                               btfsc    v_intcon, 7 ; intcon_gie
                               bsf      v____bitbucket_5, 0 ; gie_old
;  100    while serial_sw_interrupt loop
l__l109
                               btfss    v_intcon, 7 ; intcon_gie
                               goto     l__l110
;  101       serial_sw_interrupt = false
                               bcf      v_intcon, 7 ; intcon_gie
;  102    end loop
                               goto     l__l109
l__l110
;  105       serial_sw_tx_pin = low
                               bcf      v_porta_shadow_, 0 ; x23
; C://jallib1.8//lib/12f683.jal
;  128    PORTA_ = PORTA_shadow_
                               movf     v_porta_shadow_,w
                               movwf    v_gpio_
; C://jallib1.8//lib/serial_software.jal
;  105       serial_sw_tx_pin = low
;  106       _usec_delay(serial_sw_bit_time)
                               datalo_clr v__pic_temp
                               datahi_clr v__pic_temp
                               movlw    63
                               movwf    v__pic_temp
                               branchhi_clr l__l179
                               branchlo_clr l__l179
l__l179
                               decfsz   v__pic_temp,f
                               goto     l__l179
                               nop      
                               nop      
;  107       for serial_sw_databits loop
                               clrf     v__floop9
l__l115
;  109          serial_sw_tx_pin = data_bit
                               btfsc    v___data_1, 0 ; data_bit
                               goto     l__l180
                               bcf      v_porta_shadow_, 0 ; x24
                               goto     l__l181
l__l180
                               bsf      v_porta_shadow_, 0 ; x24
l__l181
; C://jallib1.8//lib/12f683.jal
;  128    PORTA_ = PORTA_shadow_
                               movf     v_porta_shadow_,w
                               movwf    v_gpio_
; C://jallib1.8//lib/serial_software.jal
;  109          serial_sw_tx_pin = data_bit
;  110          data = data >> 1
                               bcf      v__status, v__c
                               rrf      v___data_1,f
;  111          _usec_delay(serial_sw_bit_time)
                               datalo_clr v__pic_temp
                               datahi_clr v__pic_temp
                               movlw    63
                               movwf    v__pic_temp
                               branchhi_clr l__l182
                               branchlo_clr l__l182
l__l182
                               decfsz   v__pic_temp,f
                               goto     l__l182
                               nop      
                               nop      
;  112       end loop
                               incf     v__floop9,f
                               movlw    8
                               subwf    v__floop9,w
                               btfss    v__status, v__z
                               goto     l__l115
;  114       serial_sw_tx_pin = high
                               bsf      v_porta_shadow_, 0 ; x25
; C://jallib1.8//lib/12f683.jal
;  128    PORTA_ = PORTA_shadow_
                               movf     v_porta_shadow_,w
                               movwf    v_gpio_
; C://jallib1.8//lib/serial_software.jal
;  114       serial_sw_tx_pin = high
;  115       _usec_delay(serial_sw_stopbits * serial_sw_bit_time)
                               datalo_clr v__pic_temp
                               datahi_clr v__pic_temp
                               movlw    129
                               movwf    v__pic_temp
                               branchhi_clr l__l183
                               branchlo_clr l__l183
l__l183
                               decfsz   v__pic_temp,f
                               goto     l__l183
;  134    serial_sw_interrupt = gie_old
                               btfsc    v____bitbucket_5, 0 ; gie_old
                               goto     l__l184
                               bcf      v_intcon, 7 ; intcon_gie
                               return   
l__l184
                               bsf      v_intcon, 7 ; intcon_gie
;  136 end procedure
                               return   
;  232 procedure serial_sw_data'put(byte in data) is
l__serial_sw_data_put
                               datalo_clr v___data_5
                               movwf    v___data_5
;  233    serial_sw_write(data)
                               goto     l_serial_sw_write
;  234 end procedure
;  315 end function
l__l148
; C:\Users\pcser\Documents\Hobbielektronika\2023HE\JAL\Lab02\sw_serial_h.jal
;   14 serial_sw_init()                          -- SW UART inicializálása
                               call     l_serial_sw_init
;   16 forever loop
l__l166
;   17   serial_sw_data = 72                    -- Egy 'H' karakter kiírása
                               movlw    72
                               call     l__serial_sw_data_put
;   18   delay_1ms(1)
                               movlw    1
                               datalo_clr v___n_3
                               movwf    v___n_3
                               clrf     v___n_3+1
                               call     l_delay_1ms
;   19 end loop
                               goto     l__l166
                               end
